// EEG BRICK 
//  MKR WIFI 2010 __SAMD21G18A__
// Output to serial Interface !!



// I2C Select: clken selen mosien led0 sense1 sense2 sense3 spez
//             0     1      2      3     4     5      6      7
//             out   out    out   out   in     in     in     in
//

#include <Wire.h> // Definitionen laden fuer I2C
#include <SPI.h>
#include <avr/pgmspace.h> // weitere Definitionen

// USe IOs of MKR
#ifdef ARDUINO_SAMD_MKRWIFI1010
#define __AVR_SAMD21__   1
 
#endif

  
// Alle Adressen bei den 8574xx bricks:
#define i2cIO9534_0 (0x40>>1) // Trick um elegant mit Bytes
#define i2cIO9534_1 (0x42>>1) // zu arbeiten statt in 7 Bit
#define i2cIO9534_2 (0x44>>1) // das letzte Bit ist das R/W
#define i2cIO9534_3 (0x46>>1) // dass von der Arduino
#define i2cIO9534_4 (0x48>>1) // Bibliothek dazugefuegt wird
#define i2cIO9534_5 (0x4A>>1) // wir definieren hier alle 
#define i2cIO9534_6 (0x4C>>1) // Bereiche die man mit den 
#define i2cIO9534_7 (0x4E>>1) // Bricks einstellen kann,.

#define i2cIO9534A_0 (0x70>>1) // Die Serie PCF8474AT
#define i2cIO9534A_1 (0x72>>1) // beginnt bei Adresse
#define i2cIO9534A_2 (0x74>>1) // 0x70 = 70 sedezimal
#define i2cIO9534A_3 (0x76>>1)  // 01110000 binaer
#define i2cIO9534A_4 (0x78>>1) // oder intern 0111000
#define i2cIO9534A_5 (0x7A>>1) // dabei 0111xxx
#define i2cIO9534A_6 (0x7C>>1) // mit x fuer die 
#define i2cIO9534A_7 (0x7E>>1) // Dilschalterposition

#define myi2cIOadr i2cIO9534_0 // HIER PASSENDE ADRESSE EINTRAGEN

#define SSPB 10 // Pin 10 = SS  - --- PB2  1<<2 als Maske

// SPI: SCLK MOSI MISO und SS Brick=PB2 D10 fest !!
// MEGA Pin 51=MOSI Pin 52=SCK und Pin50=MISO °!!!
// mega:   
// NANO: MOSI:PB3 D11, MISO: PB4 D12, -SS:PB2:D10 
// UNO: MOSI: PB3 D11, MISO: PB4 D12, -SS:PB2:D10
// ACHUNG: MISO ist auch STatus DATA READY !!!
// 
// PORTB 4  (7 6 5 4 -- 3 2 1 0)
// BEI MKR PD6 

#if defined(__AVR_ATmega2560__)  // Arduino MEGA2560
#define MISOPIN 50
#warning ("INFO : compiles for AT MEGA2560") 
#elif defined(__AVR_SAMD21__)
#warning ("INFO : compiles for MKR WIFI1010") 
#define MISOPIN 2  // READ ONLY MKR ueber Diode...
#else // NANO
#warning ("INFO : compiles rest: also NANO...") 
#define MISOPIN 12
#endif

// #define MISOPIN 50

void enabless()
{
  //digitalWrite(SSPB, LOW);
  #if defined(__AVR_SAMD21__)
    digitalWrite(7, LOW);
  #else
   PORTB &= 0xfb; // Default = high 7 6 5 4 3 2low 1 0 PB2 low
  #endif
  delayMicroseconds(10);
}
void disabless()
{
  delayMicroseconds(10);
  #if defined(__AVR_SAMD21__)
    digitalWrite(7, HIGH);
  #else
    PORTB |= 1 << 2; // Default = high bit2 PB2
  #endif
  // digitalWrite(SSPB, HIGH);
  delayMicroseconds(10);
  // 
}

//AD 7177-x
// Register
// SS:-------_______________----------  

// 
unsigned short ad71_readid()
{
  unsigned char ch1;
  unsigned short val1=0;
  enabless();
  ch1 = SPI.transfer(0x47); // COmm: -wen r-w ra5..9  r-1=1 read 0=writ
  val1 = SPI.transfer16(0); // ID 
  disabless();
  return(val1);
}

//

//
#define NOCHAN 1

void ad71_init()
{
   enabless();
   // Register setzen...
   SPI.transfer(0x01); SPI.transfer16(0x800C);  // ADCMODE ! ref en, mode continouus, clock Crystal : 100 00 000  0 000 11 00
   SPI.transfer(0x02); SPI.transfer16(0x0442);  // INTERFACE MOD data_stat(6)en w32 en --- 000 0   0 10 0    0 1   0 0  00 1 0  old 0x0042
   SPI.transfer(0x06); SPI.transfer16(0x060d);  // GPIO 000 0  0 11 0   0 0 00 1101  
   // Channel 0
   SPI.transfer(0x10); SPI.transfer16(0x8043);  // CH0   enable set0 ain0 ain1 ... 10 00 00 00 000 0 0001  OLD:0 Chenael Tausch!!
   // Channel 1
   SPI.transfer(0x11); SPI.transfer16(0x0043);  // CH1   enable set0 ain2 ain3 ... 10 00 00 00 010 0 0011  
   // Channel 2
   SPI.transfer(0x12); SPI.transfer16(0x0096);  // CH2   enable set0 ain4 ref- ... 10 00 00 00 100 1 0110  
   // Channel 3  optional
   SPI.transfer(0x13); SPI.transfer16(0x0232);  // CH3   enable set0 smp+ tmp- ... 10 00 00 10 001 1 0010  
   // alle gleiches setup daher setup 0
   // SETup registers.
   SPI.transfer(0x20); SPI.transfer16(0x1300);  // SET0 : 000 1  0 0 1 1  0 0 00 0000
   SPI.transfer(0x21); SPI.transfer16(0x1300);  // SET1 : 000 1  0 0 1 1  0 0 00 0000
   SPI.transfer(0x22); SPI.transfer16(0x1300);  // SET2 : 000 1  0 0 1 1  0 0 00 0000
   SPI.transfer(0x23); SPI.transfer16(0x1300);  // SET3 : 000 1  0 0 1 1  0 0 00 0000
   // Filter Config gehoeren zu setup reg
   SPI.transfer(0x28); SPI.transfer16(0x050e);  // FLT0 : 0 000 0 101   x 00 0 1010 sps (00111 10k 01000 5k...)
   SPI.transfer(0x29); SPI.transfer16(0x050a);  // FLT1 : 0 000 0 101   x 00 0 1010 sps (00111 10k 01000 5k...)
   SPI.transfer(0x2A); SPI.transfer16(0x050a);  // FLT2 : 0 000 0 101   x 00 0 1010 sps (00111 10k 01000 5k...)
   SPI.transfer(0x2B); SPI.transfer16(0x050a);  // FLT3 : 0 000 0 101   x 00 0 1010 sps (00111 10k 01000 5k...)
   // OFFSET und GAIN auf factory lassen...
   disabless();
  
}

unsigned long values[4];

// tmperature 470uV/K 
//         1181972248 beispiel bei 2.5V Ref+- 0.137mV 292K ->19.7
// 67BCCE0 108776672 -3.5


void ad71_reset()
{
  enabless();
  SPI.transfer(0xff); 
  SPI.transfer(0xff); 
  SPI.transfer(0xff); 
  SPI.transfer(0xff); 
  SPI.transfer(0xff); 
  SPI.transfer(0xff); 
  SPI.transfer(0xff); 
  SPI.transfer(0xff); 
  disabless();
  delayMicroseconds(550);
}


void ad71_dataread()
{
  // Wenn ready incl status 4 byts 32 bit 
  // STATUS 
  unsigned char sts;
  unsigned char ch1;
  unsigned long val1=0;
  unsigned long val2=0;
  unsigned int idx;
  static int first = 0;
  int val=0;
  int i=0;
  for (i=0; i<NOCHAN;i++) {
    // SYNC:
    // NICHT RDY Abfragen,,, 
  #ifdef XXXXXX  
    enabless();
    do {
     
      sts = SPI.transfer(0x40); 
      sts = SPI.transfer(0x00); 
       delayMicroseconds(10);
       // Serial.print(sts);
       // Serial.println("S wt:");
    
    } while (((sts & 0x80)== 0x80) && (first == 1));
    first = 1;
    disabless();
#endif
    
    // DATA RDY
    delayMicroseconds(10);
    //
    enabless();
    delayMicroseconds(4); // DRDY valid...
    // SINGLE MODE SPI.transfer(0x01); SPI.transfer16(0x801C);  // ADCMODE ! ref en, mode SINGLE, clock Crystal : 100 00 000  0 000 11 00
    //
    // Sonst abfragen hier immer...
    do { 
      val = digitalRead(MISOPIN); // MISOPIN
    } while (val == HIGH);  
 
    // 
    ch1 = SPI.transfer(0x44); // COmm:  data read

    //
    val1 = SPI.transfer16(0); // data <
    val2 = SPI.transfer16(0); // data 
    //      
   
     //
    delayMicroseconds(5); // DRDY valid...
    disabless();
    // 
    val1 = val2 | (val1 << 16); // 4 bit status
    idx = val2 & 0x3; // CHANNEL FLG  bit 3210
    values[idx] = val1 & 0xfffffff0;
    
  }
}

void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
  Serial.println("Starting EEG:");

  #if defined(__AVR_SAMD21__)
   pinMode(MISOPIN, INPUT); // MISO !! 
   pinMode(7, OUTPUT);
  #else 
   pinMode(12, INPUT); // MISO !! 
   pinMode(SSPB, OUTPUT);
  #endif
  disabless();

  Wire.begin(); // I2C aktivieren ! 
  Wire.beginTransmission(myi2cIOadr);// Startvorgang I2C Adresse
  Wire.write(0x03) ; // IO Ports auf 01010101 abwechseln
  Wire.write(0xF0) ;  // 1=input 
  Wire.endTransmission(); // Stop Kondition setzen bei I2C
  Wire.beginTransmission(myi2cIOadr);// Startvorgang I2C Adresse
  Wire.write(0x01) ; // IO Ports auf 01010101 abwechseln
  Wire.write(0x0f) ;  // led an !! 
  Wire.endTransmission(); // Stop Kondition setzen bei I2C
  // INIT 
   SPI.begin();
  SPI.beginTransaction(SPISettings(7000000, MSBFIRST, SPI_MODE3));
  // NICHT VERWENDEN: 
  //SPI.setDataMode(SPI_MODE3);  // sonst immer 1     clk ---____----   rising edhe = spi mode 3 krit mkr´
  //SPI.setClockDivider(8);
 
  Serial.println("Searching EEG:");
  unsigned short id=ad71_readid(); // 0x4fdx
  while ((id & 0xfff0)!= 0x4fd0) {
     Serial.print("ERROR id=");Serial.print(id);
     Serial.println(" EEG Brick not found");
     Wire.beginTransmission(myi2cIOadr);// Startvorgang I2C Adresse
     Wire.write(0x01) ; // IO Ports auf 01010101 abwechseln
     Wire.write(0x07) ;  // led an !! 
     Wire.endTransmission(); // Stop Kondition setzen bei I2C
     delay(100);
     Wire.beginTransmission(myi2cIOadr);// Startvorgang I2C Adresse
     Wire.write(0x01) ; // IO Ports auf 01010101 abwechseln
     Wire.write(0x0f) ;  // led an !! 
     Wire.endTransmission(); // Stop Kondition setzen bei I2C
     delay(100);
     id=ad71_readid(); // 0x4fdx
  }
  Serial.print("id=");Serial.println(id);
  // OK Init dr Register
  ad71_reset();
  ad71_init();
}

void loop() {

ad71_dataread();
#ifdef ALLL
  Serial.print("ad:");Serial.print(values[0],HEX);
  Serial.print(" ");Serial.print(values[1],HEX);
  Serial.print(" ");Serial.print(values[2],HEX);
  Serial.print(" ");Serial.print(values[3],HEX);
  Serial.println();
#endif
  long v1 = values[0]-0x80000000l;
  // long v2 = values[1]-0x80000000l;
 //Serial.print(v1);Serial.print(",");Serial.println(v2);
 Serial.println(v1);
}
